#include <winsock2.h>
#include <Ws2tcpip.h>
#include <mswsock.h>
#include <stdio.h>
#include <stdlib.h>

int join_ssm_group(int s, UINT32 group, UINT32 source, UINT32 inter) {
   struct ip_mreq_source imr; 
   imr.imr_multiaddr.s_addr  = group;
   imr.imr_sourceaddr.s_addr = source;
   imr.imr_interface.s_addr  = inter;
   return setsockopt(s, IPPROTO_IP, IP_ADD_SOURCE_MEMBERSHIP, (char *) &imr, sizeof(imr));  
}

int main(int argc, char *argv[]) {
    
    if (argc<3) {
        printf(" Use: %s <group> <source> <port>", argv[0]);
        return 1;
    } 
    
    // Init WinSock
    WSAData data;
    WSAStartup( MAKEWORD( 2, 2 ), &data );

    //  Make socket 
    int sd = socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
    
    sockaddr_in Sender;
    int SenderAddrSize = sizeof( Sender );
    
    struct sockaddr_in binda;
    
    //  Bind it to listen appropriate UDP port
    binda.sin_family = AF_INET;
    binda.sin_port = htons( atoi(argv[3]));
    binda.sin_addr.s_addr = htonl(INADDR_ANY);
    bind(sd,(struct sockaddr*)&binda, sizeof(binda));

    // Join to group
    join_ssm_group( sd, inet_addr(argv[1]), 
                        inet_addr(argv[2]), 
                        INADDR_ANY );
        
    char        buf[65536];
    UINT32      seq;
    
    while(1) {
        int res=recvfrom(sd,(char*)buf,sizeof(buf),0, (SOCKADDR *)& Sender, &SenderAddrSize);
        seq = *(UINT32*)buf;
        printf("%12s:seq=%6d:len=%4d\n", inet_ntoa(Sender.sin_addr), seq, res);
    }
    
    return 0;
}